Bug 640399

Summary: Bundled library in mldonkey - ocaml-bitstring
Product: [Fedora] Fedora Reporter: Peter Lemenkov <lemenkov>
Component: mldonkeyAssignee: Gerald Cox <gbcox>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: rawhideCC: fedora-ocaml-list, lemenkov, rjones
Target Milestone: ---Keywords: Tracking
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: mldonkey-3.1.5-9.fc25 mldonkey-3.1.5-9.fc24 mldonkey-3.1.5-9.fc23 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2016-08-31 16:30:16 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Attachments:
Description Flags
bitstring_persistent.mli diff
none
bitstring.mli diff
none
bitstring_c.c diff none

Description Peter Lemenkov 2010-10-05 18:22:50 UTC
See src/utils/bitstring

Comment 1 Richard W.M. Jones 2010-10-06 07:54:51 UTC
Ugh, why are they bundling it?

Anyway it's in Fedora and I'll be very annoyed if they have patched
it without feeding the patches back to me upstream.

Comment 2 Peter Lemenkov 2010-10-06 08:13:15 UTC
Unfortunately after close examination I found that there are more bundled libraries here - I'll try to inspect whether they patched them before bundling.

Comment 3 Fedora End Of Life 2013-04-03 20:08:24 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19

Comment 4 Fedora Admin XMLRPC Client 2013-11-06 15:11:56 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 5 Fedora End Of Life 2015-01-09 21:45:57 UTC
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 6 Richard W.M. Jones 2015-01-19 12:32:48 UTC
Still bundled in mldonkey 3.1.5.

Comment 7 Fedora Admin XMLRPC Client 2016-02-26 17:39:28 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 8 Fedora Admin XMLRPC Client 2016-06-21 21:01:44 UTC
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.

Comment 9 Gerald Cox 2016-06-22 12:44:39 UTC
(In reply to Richard W.M. Jones from comment #6)
> Still bundled in mldonkey 3.1.5.

This bug has been open for a very long time.  Before I reinvent the wheel here, did anyone ever contact upstream about this to find out what was going on?  Last update on mldonkey was done in March, 2014.

Comment 10 Richard W.M. Jones 2016-06-22 13:06:15 UTC
I don't recall upstream being contacted about this.  However we
have ocaml-bitstring in Fedora, so there's no need for it to be
bundled.

Comment 11 Gerald Cox 2016-06-22 14:30:09 UTC
A quick cursory look shows several files which aren't in Fedora:

bitstring_c.c
bitstring_persistent.mlc4
bitstring.ml.in
pa_bitstring.mlt

There are two files which are:
bitstring_persistent.mli and bitstring.mli

I did a quick compile where I removed those two files and it seemed to complete ok... but need to do further testing.

Not sure if you want to add the files above to your library or not.  If so, please advise... otherwise, I will just test with removing the two files
which are included in Fedora... if all works, will update and then close.

Comment 12 Richard W.M. Jones 2016-06-22 15:04:28 UTC
bitstring_c.c is a C source file.  In Fedora it is compiled into
/usr/lib64/ocaml/stublibs/dllbitstring.so and
/usr/lib64/ocaml/bitstring/bitstring.a.

For the others:

bitstring_persistent.mlc4
bitstring.ml.in
pa_bitstring.mlt

I suspect they're doing some sort of preprocessing on my
sources.

Anyhow, no parts of bitstring need to be included in mldonkey
at all.  It should just link against the Fedora package, and use
the Fedora pa_bitstring language extension.

Comment 13 Gerald Cox 2016-06-22 15:12:56 UTC
After looking closer found that the two files:
bitstring_persistent.mli and bitstring.mli have been modified.  They are different than what is in Fedora.

Comment 14 Richard W.M. Jones 2016-06-22 15:16:53 UTC
If you can send me the diffs (pref against upstream:
http://git.annexia.org/?p=ocaml-bitstring.git;a=summary )
I can try to sort out this mess, if it is salvagable.

Comment 15 Gerald Cox 2016-06-22 15:35:44 UTC
sure... and it also appears that bitstring_c.c was changed... ugh...
probably will be either later today or tomorrow... 

Thanks for your help!

Comment 16 Gerald Cox 2016-06-22 16:09:16 UTC
Created attachment 1170874 [details]
bitstring_persistent.mli diff

Comment 17 Gerald Cox 2016-06-22 16:09:51 UTC
Created attachment 1170875 [details]
bitstring.mli diff

Comment 18 Gerald Cox 2016-06-22 16:10:24 UTC
Created attachment 1170876 [details]
bitstring_c.c diff

Comment 19 Gerald Cox 2016-08-22 18:26:44 UTC
Adding provides statement to reflect change in Fedora bundling policy:
https://fedoraproject.org/wiki/Bundled_Libraries?rd=Packaging:Bundled_Libraries

Comment 20 Fedora Update System 2016-08-22 19:08:51 UTC
mldonkey-3.1.5-9.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-8365ef5455

Comment 21 Fedora Update System 2016-08-22 19:09:22 UTC
mldonkey-3.1.5-9.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-f20edd423e

Comment 22 Fedora Update System 2016-08-22 19:09:51 UTC
mldonkey-3.1.5-9.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-e3a118ff46

Comment 23 Fedora Update System 2016-08-22 23:51:36 UTC
mldonkey-3.1.5-9.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-8365ef5455

Comment 24 Fedora Update System 2016-08-23 16:19:53 UTC
mldonkey-3.1.5-9.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-e3a118ff46

Comment 25 Fedora Update System 2016-08-23 16:21:46 UTC
mldonkey-3.1.5-9.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-f20edd423e

Comment 26 Fedora Update System 2016-08-31 16:30:12 UTC
mldonkey-3.1.5-9.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 27 Fedora Update System 2016-09-01 03:20:07 UTC
mldonkey-3.1.5-9.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 28 Fedora Update System 2016-09-01 03:20:45 UTC
mldonkey-3.1.5-9.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.